Index: mythtv/libs/libmythhdhomerun/hdhomerun_discover.c
===================================================================
--- mythtv/libs/libmythhdhomerun/hdhomerun_discover.c	(revision 24016)
+++ mythtv/libs/libmythhdhomerun/hdhomerun_discover.c	(working copy)
@@ -1,7 +1,7 @@
 /*
  * hdhomerun_discover.c
  *
- * Copyright © 2006-2010 Silicondust USA Inc. <www.silicondust.com>.
+ * Copyright © 2006-2007 Silicondust USA Inc. <www.silicondust.com>.
  *
  * This library is free software; you can redistribute it and/or 
  * modify it under the terms of the GNU Lesser General Public
@@ -44,11 +44,17 @@
 #endif
 #endif
 
+#include <sys/param.h>  // Defines BSD on FreeBSD and Mac OS X
+#if defined(__linux__) || defined(__APPLE__) || defined(BSD)
+#  include <ifaddrs.h>
+#  define USE_IFADDRS 1
+#  include <sys/select.h>
+#endif
+
 #define HDHOMERUN_DISOCVER_MAX_SOCK_COUNT 16
 
 struct hdhomerun_discover_sock_t {
-	hdhomerun_sock_t sock;
-	bool_t detected;
+	int sock;
 	uint32_t local_ip;
 	uint32_t subnet_mask;
 };
@@ -60,74 +66,48 @@
 	struct hdhomerun_pkt_t rx_pkt;
 };
 
-static bool_t hdhomerun_discover_sock_add(struct hdhomerun_discover_t *ds, uint32_t local_ip, uint32_t subnet_mask)
+static bool_t hdhomerun_discover_sock_create(struct hdhomerun_discover_t *ds, uint32_t local_ip, uint32_t subnet_mask)
 {
-	unsigned int i;
-	for (i = 1; i < ds->sock_count; i++) {
-		struct hdhomerun_discover_sock_t *dss = &ds->socks[i];
-
-		if ((dss->local_ip == local_ip) && (dss->subnet_mask == subnet_mask)) {
-			dss->detected = TRUE;
-			return TRUE;
-		}
-	}
-
 	if (ds->sock_count >= HDHOMERUN_DISOCVER_MAX_SOCK_COUNT) {
 		return FALSE;
 	}
 
 	/* Create socket. */
-	hdhomerun_sock_t sock = hdhomerun_sock_create_udp();
-	if (sock == HDHOMERUN_SOCK_INVALID) {
+	int sock = (int)socket(AF_INET, SOCK_DGRAM, 0);
+	if (sock == -1) {
 		return FALSE;
 	}
 
+	/* Set timeouts. */
+	setsocktimeout(sock, SOL_SOCKET, SO_SNDTIMEO, 1000);
+	setsocktimeout(sock, SOL_SOCKET, SO_RCVTIMEO, 1000);
+
+	/* Allow broadcast. */
+	int sock_opt = 1;
+	setsockopt(sock, SOL_SOCKET, SO_BROADCAST, (char *)&sock_opt, sizeof(sock_opt));
+
 	/* Bind socket. */
-	if (!hdhomerun_sock_bind(sock, local_ip, 0)) {
-		hdhomerun_sock_destroy(sock);
+	struct sockaddr_in sock_addr;
+	memset(&sock_addr, 0, sizeof(sock_addr));
+	sock_addr.sin_family = AF_INET;
+	sock_addr.sin_addr.s_addr = htonl(local_ip);
+	sock_addr.sin_port = htons(0);
+	if (bind(sock, (struct sockaddr *)&sock_addr, sizeof(sock_addr)) != 0) {
+		close(sock);
 		return FALSE;
 	}
 
 	/* Write sock entry. */
 	struct hdhomerun_discover_sock_t *dss = &ds->socks[ds->sock_count++];
 	dss->sock = sock;
-	dss->detected = TRUE;
 	dss->local_ip = local_ip;
 	dss->subnet_mask = subnet_mask;
 
 	return TRUE;
 }
 
-struct hdhomerun_discover_t *hdhomerun_discover_create(void)
-{
-	struct hdhomerun_discover_t *ds = (struct hdhomerun_discover_t *)calloc(1, sizeof(struct hdhomerun_discover_t));
-	if (!ds) {
-		return NULL;
-	}
-
-	/* Create a routable socket (always first entry). */
-	if (!hdhomerun_discover_sock_add(ds, 0, 0)) {
-		free(ds);
-		return NULL;
-	}
-
-	/* Success. */
-	return ds;
-}
-
-void hdhomerun_discover_destroy(struct hdhomerun_discover_t *ds)
-{
-	unsigned int i;
-	for (i = 0; i < ds->sock_count; i++) {
-		struct hdhomerun_discover_sock_t *dss = &ds->socks[i];
-		hdhomerun_sock_destroy(dss->sock);
-	}
-
-	free(ds);
-}
-
 #if defined(USE_IPHLPAPI)
-static void hdhomerun_discover_sock_detect_internal(struct hdhomerun_discover_t *ds)
+static void hdhomerun_discover_sock_detect(struct hdhomerun_discover_t *ds)
 {
 	PIP_ADAPTER_INFO pAdapterInfo = (IP_ADAPTER_INFO *)malloc(sizeof(IP_ADAPTER_INFO));
 	ULONG ulOutBufLen = sizeof(IP_ADAPTER_INFO);
@@ -158,7 +138,7 @@
 				continue;
 			}
 
-			hdhomerun_discover_sock_add(ds, local_ip, mask);
+			hdhomerun_discover_sock_create(ds, local_ip, mask);
 			pIPAddr = pIPAddr->Next;
 		}
 
@@ -170,9 +150,12 @@
 
 #else
 
-static void hdhomerun_discover_sock_detect_internal(struct hdhomerun_discover_t *ds)
+static void hdhomerun_discover_sock_detect(struct hdhomerun_discover_t *ds)
 {
-	int sock = ds->socks[0].sock;
+	int fd = socket(AF_INET, SOCK_DGRAM, 0);
+	if (fd == -1) {
+		return;
+	}
 
 	struct ifconf ifc;
 	uint8_t buf[8192];
@@ -181,7 +164,8 @@
 
 	memset(buf, 0, sizeof(buf));
 
-	if (ioctl(sock, SIOCGIFCONF, &ifc) != 0) {
+	if (ioctl(fd, SIOCGIFCONF, &ifc) != 0) {
+		close(fd);
 		return;
 	}
 
@@ -192,7 +176,7 @@
 		struct ifreq *ifr = (struct ifreq *)ptr;
 		ptr += _SIZEOF_ADDR_IFREQ(*ifr);
 
-		if (ioctl(sock, SIOCGIFADDR, ifr) != 0) {
+		if (ioctl(fd, SIOCGIFADDR, ifr) != 0) {
 			continue;
 		}
 		struct sockaddr_in *addr_in = (struct sockaddr_in *)&(ifr->ifr_addr);
@@ -201,45 +185,48 @@
 			continue;
 		}
 
-		if (ioctl(sock, SIOCGIFNETMASK, ifr) != 0) {
+		if (ioctl(fd, SIOCGIFNETMASK, ifr) != 0) {
 			continue;
 		}
 		struct sockaddr_in *mask_in = (struct sockaddr_in *)&(ifr->ifr_addr);
 		uint32_t mask = ntohl(mask_in->sin_addr.s_addr);
 
-		hdhomerun_discover_sock_add(ds, local_ip, mask);
+		hdhomerun_discover_sock_create(ds, local_ip, mask);
 	}
+
+	close(fd);
 }
 #endif
 
-static void hdhomerun_discover_sock_detect(struct hdhomerun_discover_t *ds)
+static struct hdhomerun_discover_t *hdhomerun_discover_create(void)
 {
-	unsigned int i;
-	for (i = 1; i < ds->sock_count; i++) {
-		struct hdhomerun_discover_sock_t *dss = &ds->socks[i];
-		dss->detected = FALSE;
+	struct hdhomerun_discover_t *ds = (struct hdhomerun_discover_t *)calloc(1, sizeof(struct hdhomerun_discover_t));
+	if (!ds) {
+		return NULL;
 	}
 
-	hdhomerun_discover_sock_detect_internal(ds);
+	/* Create a routable socket. */
+	if (!hdhomerun_discover_sock_create(ds, 0, 0)) {
+		free(ds);
+		return NULL;
+	}
 
-	struct hdhomerun_discover_sock_t *src = &ds->socks[1];
-	struct hdhomerun_discover_sock_t *dst = &ds->socks[1];
-	unsigned int count = 1;
-	for (i = 1; i < ds->sock_count; i++) {
-		if (!src->detected) {
-			hdhomerun_sock_destroy(src->sock);
-			src++;
-			continue;
-		}
-		if (dst != src) {
-			*dst = *src;
-		}
-		src++;
-		dst++;
-		count++;
+	/* Detect & create local sockets. */
+	hdhomerun_discover_sock_detect(ds);
+
+	/* Success. */
+	return ds;
+}
+
+static void hdhomerun_discover_destroy(struct hdhomerun_discover_t *ds)
+{
+	unsigned int i;
+	for (i = 0; i < ds->sock_count; i++) {
+		struct hdhomerun_discover_sock_t *dss = &ds->socks[i];
+		close(dss->sock);
 	}
 
-	ds->sock_count = count;
+	free(ds);
 }
 
 static bool_t hdhomerun_discover_send_internal(struct hdhomerun_discover_t *ds, struct hdhomerun_discover_sock_t *dss, uint32_t target_ip, uint32_t device_type, uint32_t device_id)
@@ -255,7 +242,18 @@
 	hdhomerun_pkt_write_u32(tx_pkt, device_id);
 	hdhomerun_pkt_seal_frame(tx_pkt, HDHOMERUN_TYPE_DISCOVER_REQ);
 
-	return hdhomerun_sock_sendto(dss->sock, target_ip, HDHOMERUN_DISCOVER_UDP_PORT, tx_pkt->start, tx_pkt->end - tx_pkt->start, 0);
+	struct sockaddr_in sock_addr;
+	memset(&sock_addr, 0, sizeof(sock_addr));
+	sock_addr.sin_family = AF_INET;
+	sock_addr.sin_addr.s_addr = htonl(target_ip);
+	sock_addr.sin_port = htons(HDHOMERUN_DISCOVER_UDP_PORT);
+
+	int length = (int)(tx_pkt->end - tx_pkt->start);
+	if (sendto(dss->sock, (char *)tx_pkt->start, length, 0, (struct sockaddr *)&sock_addr, sizeof(sock_addr)) != length) {
+		return FALSE;
+	}
+
+	return TRUE;
 }
 
 static bool_t hdhomerun_discover_send_wildcard_ip(struct hdhomerun_discover_t *ds, uint32_t device_type, uint32_t device_id)
@@ -315,36 +313,38 @@
 
 static bool_t hdhomerun_discover_send(struct hdhomerun_discover_t *ds, uint32_t target_ip, uint32_t device_type, uint32_t device_id)
 {
-	if (target_ip == 0) {
-		return hdhomerun_discover_send_wildcard_ip(ds, device_type, device_id);
-	} else {
+	if (target_ip != 0) {
 		return hdhomerun_discover_send_target_ip(ds, target_ip, device_type, device_id);
 	}
+
+	return hdhomerun_discover_send_wildcard_ip(ds, device_type, device_id);
 }
 
-static bool_t hdhomerun_discover_recv_internal(struct hdhomerun_discover_t *ds, struct hdhomerun_discover_sock_t *dss, struct hdhomerun_discover_device_t *result)
+static int hdhomerun_discover_recv_internal(struct hdhomerun_discover_t *ds, struct hdhomerun_discover_sock_t *dss, struct hdhomerun_discover_device_t *result)
 {
 	struct hdhomerun_pkt_t *rx_pkt = &ds->rx_pkt;
 	hdhomerun_pkt_reset(rx_pkt);
 
-	uint32_t remote_addr;
-	uint16_t remote_port;
-	size_t length = rx_pkt->limit - rx_pkt->end;
-	if (!hdhomerun_sock_recvfrom(dss->sock, &remote_addr, &remote_port, rx_pkt->end, &length, 0)) {
-		return FALSE;
+	struct sockaddr_in sock_addr;
+	memset(&sock_addr, 0, sizeof(sock_addr));
+	socklen_t sockaddr_size = sizeof(sock_addr);
+
+	int rx_length = recvfrom(dss->sock, (char *)rx_pkt->end, (int)(rx_pkt->limit - rx_pkt->end), 0, (struct sockaddr *)&sock_addr, &sockaddr_size);
+	if (rx_length <= 0) {
+		/* Don't return error - windows machine on VPN can sometimes cause a sock error here but otherwise works. */
+		return 0;
 	}
+	rx_pkt->end += rx_length;
 
-	rx_pkt->end += length;
-
 	uint16_t type;
 	if (hdhomerun_pkt_open_frame(rx_pkt, &type) <= 0) {
-		return FALSE;
+		return 0;
 	}
 	if (type != HDHOMERUN_TYPE_DISCOVER_RPY) {
-		return FALSE;
+		return 0;
 	}
 
-	result->ip_addr = remote_addr;
+	result->ip_addr = ntohl(sock_addr.sin_addr.s_addr);
 	result->device_type = 0;
 	result->device_id = 0;
 
@@ -378,40 +378,63 @@
 		rx_pkt->pos = next;
 	}
 
-	return TRUE;
+	return 1;
 }
 
-static bool_t hdhomerun_discover_recv(struct hdhomerun_discover_t *ds, struct hdhomerun_discover_device_t *result)
+static int hdhomerun_discover_recv(struct hdhomerun_discover_t *ds, struct hdhomerun_discover_device_t *result)
 {
+	struct timeval t;
+	t.tv_sec = 0;
+	t.tv_usec = 250000;
+
+	fd_set readfds;
+	FD_ZERO(&readfds);
+	int max_sock = -1;
+
 	unsigned int i;
 	for (i = 0; i < ds->sock_count; i++) {
 		struct hdhomerun_discover_sock_t *dss = &ds->socks[i];
+		FD_SET(dss->sock, &readfds);
+		if (dss->sock > max_sock) {
+			max_sock = dss->sock;
+		}
+	}
 
-		if (hdhomerun_discover_recv_internal(ds, dss, result)) {
-			return TRUE;
+	if (select(max_sock+1, &readfds, NULL, NULL, &t) < 0) {
+		return -1;
+	}
+
+	for (i = 0; i < ds->sock_count; i++) {
+		struct hdhomerun_discover_sock_t *dss = &ds->socks[i];
+		if (!FD_ISSET(dss->sock, &readfds)) {
+			continue;
 		}
+
+		if (hdhomerun_discover_recv_internal(ds, dss, result) <= 0) {
+			continue;
+		}
+
+		return 1;
 	}
 
-	return FALSE;
+	return 0;
 }
 
-static struct hdhomerun_discover_device_t *hdhomerun_discover_find_in_list(struct hdhomerun_discover_device_t result_list[], int count, struct hdhomerun_discover_device_t *lookup)
+static struct hdhomerun_discover_device_t *hdhomerun_discover_find_in_list(struct hdhomerun_discover_device_t result_list[], int count, uint32_t ip_addr)
 {
 	int index;
 	for (index = 0; index < count; index++) {
-		struct hdhomerun_discover_device_t *entry = &result_list[index];
-		if (memcmp(lookup, entry, sizeof(struct hdhomerun_discover_device_t)) == 0) {
-			return entry;
+		struct hdhomerun_discover_device_t *result = &result_list[index];
+		if (result->ip_addr == ip_addr) {
+			return result;
 		}
 	}
 
 	return NULL;
 }
 
-int hdhomerun_discover_find_devices(struct hdhomerun_discover_t *ds, uint32_t target_ip, uint32_t device_type, uint32_t device_id, struct hdhomerun_discover_device_t result_list[], int max_count)
+static int hdhomerun_discover_find_devices_internal(struct hdhomerun_discover_t *ds, uint32_t target_ip, uint32_t device_type, uint32_t device_id, struct hdhomerun_discover_device_t result_list[], int max_count)
 {
-	hdhomerun_discover_sock_detect(ds);
-
 	int count = 0;
 	int attempt;
 	for (attempt = 0; attempt < 2; attempt++) {
@@ -420,14 +443,14 @@
 		}
 
 		uint64_t timeout = getcurrenttime() + 200;
-		while (1) {
+		while (getcurrenttime() < timeout) {
 			struct hdhomerun_discover_device_t *result = &result_list[count];
 
-			if (!hdhomerun_discover_recv(ds, result)) {
-				if (getcurrenttime() >= timeout) {
-					break;
-				}
-				msleep_approx(10);
+			int ret = hdhomerun_discover_recv(ds, result);
+			if (ret < 0) {
+				return -1;
+			}
+			if (ret == 0) {
 				continue;
 			}
 
@@ -444,7 +467,7 @@
 			}
 
 			/* Ensure not already in list. */
-			if (hdhomerun_discover_find_in_list(result_list, count, result)) {
+			if (hdhomerun_discover_find_in_list(result_list, count, result->ip_addr)) {
 				continue;
 			}
 
@@ -461,16 +484,12 @@
 
 int hdhomerun_discover_find_devices_custom(uint32_t target_ip, uint32_t device_type, uint32_t device_id, struct hdhomerun_discover_device_t result_list[], int max_count)
 {
-	if (hdhomerun_discover_is_ip_multicast(target_ip)) {
-		return 0;
-	}
-
 	struct hdhomerun_discover_t *ds = hdhomerun_discover_create();
 	if (!ds) {
 		return -1;
 	}
 
-	int ret = hdhomerun_discover_find_devices(ds, target_ip, device_type, device_id, result_list, max_count);
+	int ret = hdhomerun_discover_find_devices_internal(ds, target_ip, device_type, device_id, result_list, max_count);
 
 	hdhomerun_discover_destroy(ds);
 	return ret;
@@ -494,7 +513,3 @@
 	return (checksum == 0);
 }
 
-bool_t hdhomerun_discover_is_ip_multicast(uint32_t ip_addr)
-{
-	return (ip_addr >= 0xE0000000) && (ip_addr < 0xF0000000);
-}
Index: mythtv/libs/libmythhdhomerun/hdhomerun_discover.h
===================================================================
--- mythtv/libs/libmythhdhomerun/hdhomerun_discover.h	(revision 24016)
+++ mythtv/libs/libmythhdhomerun/hdhomerun_discover.h	(working copy)
@@ -44,11 +44,9 @@
  *
  * The device information is stored in caller-supplied array of hdhomerun_discover_device_t vars.
  * Multiple attempts are made to find devices.
- * Execution time is typically 400ms if max_count is not reached.
+ * Execution time is 1 second.
  *
  * Set target_ip to zero to auto-detect IP address.
- * Set device_type to HDHOMERUN_DEVICE_TYPE_TUNER to detect HDHomeRun tuner devices.
- * Set device_id to HDHOMERUN_DEVICE_ID_WILDCARD to detect all device ids.
  *
  * Returns the number of devices found.
  * Retruns -1 on error.
@@ -56,13 +54,6 @@
 extern LIBTYPE int hdhomerun_discover_find_devices_custom(uint32_t target_ip, uint32_t device_type, uint32_t device_id, struct hdhomerun_discover_device_t result_list[], int max_count);
 
 /*
- * Optional: persistent discover instance available for discover polling use.
- */
-extern LIBTYPE struct hdhomerun_discover_t *hdhomerun_discover_create(void);
-extern LIBTYPE void hdhomerun_discover_destroy(struct hdhomerun_discover_t *ds);
-extern LIBTYPE int hdhomerun_discover_find_devices(struct hdhomerun_discover_t *ds, uint32_t target_ip, uint32_t device_type, uint32_t device_id, struct hdhomerun_discover_device_t result_list[], int max_count);
-
-/*
  * Verify that the device ID given is valid.
  *
  * The device ID contains a self-check sequence that detects common user input errors including
@@ -73,14 +64,6 @@
  */
 extern LIBTYPE bool_t hdhomerun_discover_validate_device_id(uint32_t device_id);
 
-/*
- * Detect if an IP address is multicast.
- *
- * Returns TRUE if multicast.
- * Returns FALSE if zero, unicast, expermental, or broadcast.
- */
-extern LIBTYPE bool_t hdhomerun_discover_is_ip_multicast(uint32_t ip_addr);
-
 #ifdef __cplusplus
 }
 #endif
Index: mythtv/libs/libmythhdhomerun/Makefile.bin
===================================================================
--- mythtv/libs/libmythhdhomerun/Makefile.bin	(revision 24016)
+++ mythtv/libs/libmythhdhomerun/Makefile.bin	(working copy)
@@ -1,15 +1,12 @@
-
+LIBSRCS += hdhomerun_pkt.c
+LIBSRCS += hdhomerun_debug.c
+LIBSRCS += hdhomerun_discover.c
 LIBSRCS += hdhomerun_channels.c
 LIBSRCS += hdhomerun_channelscan.c
 LIBSRCS += hdhomerun_control.c
-LIBSRCS += hdhomerun_debug.c
+LIBSRCS += hdhomerun_video.c
 LIBSRCS += hdhomerun_device.c
 LIBSRCS += hdhomerun_device_selector.c
-LIBSRCS += hdhomerun_discover.c
-LIBSRCS += hdhomerun_os_posix.c
-LIBSRCS += hdhomerun_pkt.c
-LIBSRCS += hdhomerun_sock_posix.c
-LIBSRCS += hdhomerun_video.c
 
 CC    := $(CROSS_COMPILE)gcc
 STRIP := $(CROSS_COMPILE)strip
@@ -23,15 +20,11 @@
   LIBEXT := .dll
   LDFLAGS += -liphlpapi
 else
-  OS := $(shell uname -s)
   LIBEXT := .so
-  ifeq ($(OS),Linux)
-    LDFLAGS += -lrt
-  endif
-  ifeq ($(OS),SunOS)
+  ifneq ($(findstring solaris,$(shell echo $$OSTYPE)),)
     LDFLAGS += -lns -lsocket
   endif
-  ifeq ($(OS),Darwin)
+  ifneq ($(findstring darwin,$(shell echo $$OSTYPE)),)
     CFLAGS += -arch i386 -arch ppc
     LIBEXT := .dylib
     SHARED := -dynamiclib -install_name libhdhomerun$(LIBEXT)
Index: mythtv/libs/libmythhdhomerun/hdhomerun_device_selector.c
===================================================================
--- mythtv/libs/libmythhdhomerun/hdhomerun_device_selector.c	(revision 24016)
+++ mythtv/libs/libmythhdhomerun/hdhomerun_device_selector.c	(working copy)
@@ -1,7 +1,7 @@
 /*
  * hdhomerun_device_selector.c
  *
- * Copyright Â© 2009-2010 Silicondust USA Inc. <www.silicondust.com>.
+ * Copyright Â© 2009 Silicondust USA Inc. <www.silicondust.com>.
  *
  * This library is free software; you can redistribute it and/or 
  * modify it under the terms of the GNU Lesser General Public
@@ -68,11 +68,6 @@
 	free(hds);
 }
 
-LIBTYPE int hdhomerun_device_selector_get_device_count(struct hdhomerun_device_selector_t *hds)
-{
-	return (int)hds->hd_count;
-}
-
 void hdhomerun_device_selector_add_device(struct hdhomerun_device_selector_t *hds, struct hdhomerun_device_t *hd)
 {
 	size_t index;
@@ -134,11 +129,11 @@
 	return NULL;
 }
 
-int hdhomerun_device_selector_load_from_file(struct hdhomerun_device_selector_t *hds, char *filename)
+void hdhomerun_device_selector_load_from_file(struct hdhomerun_device_selector_t *hds, char *filename)
 {
 	FILE *fp = fopen(filename, "r");
 	if (!fp) {
-		return 0;
+		return;
 	}
 
 	while(1) {
@@ -156,17 +151,16 @@
 	}
 
 	fclose(fp);
-	return (int)hds->hd_count;
 }
 
 #if defined(__WINDOWS__)
-int hdhomerun_device_selector_load_from_windows_registry(struct hdhomerun_device_selector_t *hds, wchar_t *wsource)
+void hdhomerun_device_selector_load_from_windows_registry(struct hdhomerun_device_selector_t *hds, wchar_t *wsource)
 {
 	HKEY tuners_key;
 	LONG ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE, L"SOFTWARE\\Silicondust\\HDHomeRun\\Tuners", 0, KEY_QUERY_VALUE | KEY_ENUMERATE_SUB_KEYS, &tuners_key);
 	if (ret != ERROR_SUCCESS) {
-		hdhomerun_debug_printf(hds->dbg, "hdhomerun_device_selector_load_from_windows_registry: failed to open tuners registry key (%ld)\n", (long)ret);
-		return 0;
+		hdhomerun_debug_printf(hds->dbg, "hdhomerun_device_selector_load_from_windows_registry: failed to open tuners registry key (%ld)\n", ret);
+		return;
 	}
 
 	DWORD index = 0;
@@ -183,7 +177,7 @@
 		HKEY device_key;
 		ret = RegOpenKeyEx(tuners_key, wdevice_name, 0, KEY_QUERY_VALUE, &device_key);
 		if (ret != ERROR_SUCCESS) {
-			hdhomerun_debug_printf(hds->dbg, "hdhomerun_device_selector_load_from_windows_registry: failed to open registry key for %S (%ld)\n", wdevice_name, (long)ret);
+			hdhomerun_debug_printf(hds->dbg, "hdhomerun_device_selector_load_from_windows_registry: failed to open registry key for %S (%ld)\n", wdevice_name, ret);
 			continue;
 		}
 
@@ -213,7 +207,6 @@
 	}
 
 	RegCloseKey(tuners_key);
-	return (int)hds->hd_count;
 }
 #endif
 
@@ -275,16 +268,21 @@
 	/*
 	 * Test local port.
 	 */
-	hdhomerun_sock_t test_sock = hdhomerun_sock_create_udp();
-	if (test_sock == HDHOMERUN_SOCK_INVALID) {
+	int test_sock = (int)socket(AF_INET, SOCK_DGRAM, 0);
+	if (test_sock == -1) {
 		hdhomerun_debug_printf(hds->dbg, "hdhomerun_device_selector_choose_test: device %s in use, failed to create test sock\n", name);
 		return FALSE;
 	}
 
-	bool_t inuse = (hdhomerun_sock_bind(test_sock, INADDR_ANY, (uint16_t)target_port) == FALSE);
-	hdhomerun_sock_destroy(test_sock);
+	struct sockaddr_in sock_addr;
+	memset(&sock_addr, 0, sizeof(sock_addr));
+	sock_addr.sin_family = AF_INET;
+	sock_addr.sin_addr.s_addr = htonl(INADDR_ANY);
+	sock_addr.sin_port = htons((uint16_t)target_port);
+	ret = bind(test_sock, (struct sockaddr *)&sock_addr, sizeof(sock_addr));
+	close(test_sock);
 
-	if (inuse) {
+	if (ret != 0) {
 		hdhomerun_debug_printf(hds->dbg, "hdhomerun_device_selector_choose_test: device %s in use by local machine\n", name);
 		return FALSE;
 	}
